package teikade.debug;
import teikade.net.Packet;

public class RunClass extends Packet {
    String className;
    String classPath;
    String arguments;

    public RunClass() {
    }

    public RunClass(String className, String classPath, String arguments) {
	this.className = className;
	this.classPath = classPath;
	this.arguments = arguments;
    }

    /**
     * format: RunClass("package.className", "classPath", "arguments")
     */
    public void init() throws IllegalArgumentException {
	className = getStringArgument();
	classPath = getStringArgument();
	arguments = getStringArgument();
    }

    public void execute(Object target) {
	// ((DebuggerManager)target).runNotify(this);
    }

    /**
     * format: RunClass("package.className", "classPath", "arguments")
     */
    public String argumentsToString() {
	return toStreamString(className) + ", " +
		toStreamString(classPath) + ", " +
		toStreamString(arguments);		
    }

    /**
     * returns class name with package name
     */
    public String getClassName() {
	return className;		
    }

    /**
     * returns class path
     */
    public String getClassPath() {
	return classPath;		
    }

    /**
     * returns arguments
     */
    public String getArguments() {
	return arguments;		
    }
}
