//package teikade.debug;

import java.awt.Panel;
import java.awt.List;
import java.awt.TextArea;
import java.awt.Event;
import java.awt.GridLayout;
import java.awt.BorderLayout;
import java.util.Observer;
import java.util.Observable;

public class InspectorView extends Panel implements Observer {
    Inspector model;
    List listView;
    TextArea valueView;

    public static void openOn(Inspector inspector) {
	ApplicationFrame frame = new ApplicationFrame();
	frame.setLayout(new BorderLayout());
	frame.add("Center", new InspectorView(inspector));
	frame.resize(200, 150);
	frame.show();
    }

    InspectorView(Inspector model) {
	this.model = model;
	model.addObserver(this);
	setLayout(new GridLayout(0, 2));
	listView = new List();
	add(listView);
	valueView = new TextArea();
	add(valueView);
    }

    public boolean handleEvent(Event evt) {
	if (evt.id == Event.WINDOW_DESTROY) {
	    getParent().hide();
	    //getParent().dispose();
	}
	if (evt.target == listView) {
	    model.selected(listView.getSelectedIndex());
	}
	return super.handleEvent(evt);
    }

    /**
     * java.util.Observer stuff
     */
    public void update(Observable o, Object arg) {
	if (o == model) {
	    if (arg == Inspector.SELECTION) {
		valueView.setText(model.getValue());
	    } else if (arg == Inspector.LIST) {
		listView.clear();
		String list[] = model.getList();
		if (list != null && list.length > 0) {
		    for (int i = 0; i < list.length; i++) {
		        listView.addItem(list[i]);
		    }
		}
	    }
	}
	invalidate();
    }
}
