//package teikade.debug;

import sun.tools.debug.RemoteStackVariable;

class StackFrameInspector extends Inspector {
    RemoteStackVariable remoteStackVariables[];

    /**
     * set local variable list
     */
    void setList(RemoteStackVariable rsv[]) throws Exception {
	disposeList();
	remoteStackVariables = rsv;
	if (rsv != null && rsv.length != 0) {
	    list = new String[rsv.length];
	    for (int i = 0; i < rsv.length; i++) {
		list[i] = rsv[i].getName();
	    }
	}
	changed(LIST);
    }

    /**
     * returns string representation of selected local variable's value
     */
    String getValue() {
	if (selection != -1) {
	    RemoteStackVariable sv = remoteStackVariables[selection];
	    if (sv.inScope()) {
		try {
		    return sv.getValue().toString();
		} catch (Exception e) {
		    return "(exception: " + e + ")";
		}
	    } else {
		return "(not in scope)";
	    }
	} else {
	    return "";
	}
    }
}
