/*
 * Copyright (c) 1996 PFU Limited.
 *	author Kazuhisa Shirakami
 */
package teikade.gui.component;

import java.awt.*;
import teikade.sys.TeikadeProperties;
import teikade.sys.UseProperties;
import teikade.gui.*;
import teikade.gui.component.*;

public class DCheckboxMenuItem extends CheckboxMenuItem implements UseProperties {
    Object target;

    public DCheckboxMenuItem(String label) {
	super(label);
	updateProperties();
    }

    public DCheckboxMenuItem(String label, Object target) {
	this(label);
	this.target = target;
    }

    public void updateProperties() {
	Font font = TeikadeProperties.getFont("font.menu");
	if (font != null && !font.equals(getFont())) {
	    setFont(font);
	}
    }

    public Object getTarget() {
	return target;
    }
}
