/*
 * Copyright (c) 1995 PFU Limited.
 *	author Osamu Satoh
 */
package teikade.gui.menu;

import teikade.sys.*;
import teikade.util.*;
import teikade.lang.*;
import teikade.gui.*;
import teikade.gui.component.*;
import java.util.*;
import java.awt.*;

public class TeikadeMessagesMenu extends DMenu {
    Hashtable idspecs = new Hashtable();

    TeikadeMessagesMenu(String label) {
	super(label);
    }

    public void add(IdentifierSpec idspec) {
	Enumeration names = idspec.names();
	while (names.hasMoreElements()) {
	    String label = (String)names.nextElement();
	    idspecs.put(label, idspec);
	    add(label);
	}
    }

    public void clear() {
	for (int i = countItems(); --i >= 0; ) {
	    remove(i);
	}
	idspecs = new Hashtable();
    }

    void spawn(String label, TeikadeFrame frame, CodePath cp) {
	IdentifierSpec idspec = (IdentifierSpec)idspecs.get(label);
	frame.spawnImplementers(cp, idspec, label);
    }

    void spawn(CodePath cp, TeikadeFrame frame) {
	String select = frame.getSelectedCode();
	if (select != null && select.length() > 0) {
	    IdentifierSpec idspec = (IdentifierSpec)idspecs.get(select);
	    frame.spawnImplementers(cp, idspec, select);
	}
    }
}
