/*
 * Copyright (c) 1996 PFU Limited.
 *	author Kazuhisa Shirakami
 */
package teikade.lang;

public class JavaLexical {

    public static int isIdentifier(String name) {
	return isIdentifier(name, 0, name.length());
    }

    public static int isIdentifier(String name, String with) {
	int pos = 0;
	int length = name.length();
	int illegal;
	while ((illegal = isIdentifier(name, pos, length)) >= 0) {
	    if (with.indexOf(name.charAt(illegal)) < 0) return illegal;
	    pos++;
	}
	return -1;
    }

    public static int isIdentifier(String name, int pos, int length) {
	if (length == 0) return -1;
	if (pos == 0 && !Character.isJavaLetter(name.charAt(0))) return 0;
	for (int i = pos; i < length; i++) {
	    char c = name.charAt(i);
	    if (!Character.isJavaLetterOrDigit(name.charAt(i))) return i;
	}
	return -1;
    }
}
