/*
 * Copyright (c) 1995-1998 PFU Limited.
 *	author Osamu Satoh
 */
package teikade.sys;

import java.util.Enumeration;

/**
 * the enumurator class for linked list of Manager
 */
class ManagerEnumerator implements Enumeration {
    /**
     * current element
     */
    protected Manager manager;

    /**
     * whether this enumeration returns Manager's name or Manager itself
     */
    private boolean name;

    ManagerEnumerator(Manager manager) {
	this(manager, false);
    }

    ManagerEnumerator(Manager manager, boolean name) {
	this.manager = manager;
	this.name = name;
    }

    /*
     * java.util.Enumeration stuff
     */
    public boolean hasMoreElements() {
	return manager != null;
    }

    /*
     * java.util.Enumeration stuff
     */
    public Object nextElement(){
	Manager ret = manager;
	if (ret != null) {
	    manager = ret.brother();
	}
	if (name) {
	    return ret.name();
	} else {
	    return ret;
	}
    }
}
